Subject: Re: [PATCHv4 bpf-next 0/2] xdp: add dev map multicast support

From: Jesper Dangaard Brouer <[email-masked]>
Date: Wed, 10 Jun 2020 12:03:30 +0200

On Wed, 10 Jun 2020 10:35:08 +0800
Hangbin Liu <[email-masked]> wrote:

> On Tue, Jun 09, 2020 at 10:31:19PM +0200, Toke HÃ¸iland-JÃ¸rgensen wrote:
> > > Oh, sorry for the typo, the numbers make me crazy, it should be only
> > > ingress i40e, egress veth. Here is the right description:
> > >
> > > Kernel 5.7 + my patch(ingress i40e, egress i40e)
> > > xdp_redirect_map:
> > >   generic mode: 1.9M PPS
> > >   driver mode: 10.2M PPS
> > >
> > > xdp_redirect_map_multi:
> > >   generic mode: 1.58M PPS
> > >   driver mode: 7.16M PPS
> > >
> > > Kernel 5.7 + my patch(ingress i40e, egress veth(No XDP on peer))
> > > xdp_redirect_map:
> > >   generic mode: 2.2M PPS
> > >   driver mode: 14.2M PPS  
> > 
> > A few messages up-thread you were getting 4.15M PPS in this case - what
> > changed? It's inconsistencies like these that make me suspicious of the
> > whole set of results :/  
> 
> I got the number after a reboot, not sure what happened.
> And I also feel surprised... But the result shows the number, so I have
> to put it here.
> 
> > 
> > Are you getting these numbers from ethtool_stats.pl or from the XDP
> > program? What counter are you looking at, exactly?  
> 
> For bridge testing I use ethtool_stats.pl. For later xdp_redirect_map
> and xdp_redirect_map_multi testing, I checked that ethtool_stats.pl and
> XDP program shows the same number. When run ethtool_stats.pl the number
> will go a little bit slower. So at the end I use the xdp program's number.

You cannot trust the xdp program's number, because it just counts all
RX-packets, and don't take into account if the packets are getting
dropped.  We really want to verify (e.g. with ethtool_stats.pl) that
the packets were successfully transmitted.

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer